local addonName, addon = ...
LibStub("AceAddon-3.0"):NewAddon(addon, addonName, "AceEvent-3.0")

local UnitStat = UnitStat
local UnitAttackPower = UnitAttackPower
local UnitPower = UnitPower

function addon:OnInitialize()
	self.displayFrame = CreateFrame("frame", nil, UIParent)
	self.displayFrame:SetPoint("CENTER", UIParent, "CENTER")
	self.displayFrame:SetHeight(100)
	self.displayFrame:SetWidth(100)
	self.displayFrame.text = self.displayFrame:CreateFontString()
	self.displayFrame.text:SetAllPoints(self.displayFrame)
	self.displayFrame.text:SetFont("Fonts\\FRIZQT__.TTF", 15)
end

function addon:OnEnable()
	self:RegisterEvent("UNIT_STATS")
	self:RegisterEvent("UNIT_ATTACK_POWER")
	self:RegisterEvent("UNIT_POWER")
	self:RegisterEvent("PLAYER_ENTERING_WORLD")
end

function addon:OnDisable()

end

function addon:UNIT_STATS(event, unit) --strength changed
	if unit ~= "player" then return end
	self.str = UnitStat("player", 1)
	self:UpdateDisplay()
end

function addon:UNIT_ATTACK_POWER(event, unit) --ap changed
	if unit ~= "player" then return end
	self.ap = UnitAttackPower("player")
	self:UpdateDisplay()
end

function addon:UNIT_POWER(event, unit, powerType) --rage changed
	if unit ~= "player" then return end
	if powerType ~= "RAGE" then return end
	self.rage = UnitPower("player", 1)
	self:UpdateDisplay()
end

function addon:PLAYER_ENTERING_WORLD() --get initial values for everything
	self.str = UnitStat("player", 1)
	self.ap = UnitAttackPower("player")
	self.rage = UnitPower("player", 1)
	self:UpdateDisplay()
end

function addon:UpdateDisplay()
	self.displayFrame.text:SetText(floor(math.max(2 * (self.ap - 2 * self.str), math.min(math.max(self.rage, 20), 60) / 60 * 25000)))
end